##############################################################
######## NESDA data, IDS30-SR symptoms, years 0 & 2 ##########
##############################################################

library(qgraph)
library(ggplot2)
library(psych)
library(psych)

setwd("C:/Users/u0097060/Dropbox/Research/My Papers/1. First author publications/MI paper/analyses/R")


##### DATA PREPARATION
data<-read.csv("NESDA.csv", head=T)

# 1 df per timepoint
data.I.0 <- subset(data, select=c(V1:V28))
data.I.12 <- subset(data, select=c(V29:V56))
IDS_sum.1=(data$V1+data$V2+data$V3+data$V4+data$V5+data$V6+data$V7+data$V8+data$V9+data$V10+data$V11+data$V12+data$V13+data$V14+data$V15+data$V16+data$V17+data$V18+data$V19+data$V20+data$V21+data$V22+data$V23+data$V24+data$V25+data$V26+data$V27+data$V28+data$V29+data$V30+data$V31+data$V32+data$V33+data$V34+data$V35+data$V36+data$V37+data$V38+data$V39+data$V40+data$V41+data$V42+data$V43+data$V44+data$V45+data$V46+data$V47+data$V48+data$V49+data$V50+data$V51+data$V52+data$V53+data$V54+data$V55+data$V56)
IDS_sum.2=(data$V29+data$V30+data$V31+data$V32+data$V33+data$V34+data$V35+data$V36+data$V37+data$V38+data$V39+data$V40+data$V41+data$V42+data$V43+data$V44+data$V45+data$V46+data$V47+data$V48+data$V49+data$V50+data$V51+data$V52+data$V53+data$V54+data$V55+data$V56)
IDS_sum.1=as.data.frame(IDS_sum.1)
IDS_sum.2=as.data.frame(IDS_sum.2)


# rename symptoms
s.i=c("I01","I02","I03","I04","I05", "I06","I07","I08","I09","I10", "I11","I12", "I13","I14","I15","I16","I17","I18","I19","I20","I21","I22","I23","I24","I25","I26","I27","I28")


##### DESCRIPTIVE STATISTICS, n=496
mean(data$IDS_sum.1) # 35.50
sd(data$IDS_sum.1) # 11.32
mean(data$IDS_sum.2) # 20.60
sd(data$IDS_sum.2) # 15.26


### mean sd of all symptoms at baseline. IDS t0=0.8716156; t11=0.693754; 
(sd(data.I.0[[1]])+  sd(data.I.0[[2]])+  sd(data.I.0[[3]])+  sd(data.I.0[[4]])+  sd(data.I.0[[5]])+  sd(data.I.0[[6]])+  sd(data.I.0[[7]])+  sd(data.I.0[[8]])+  sd(data.I.0[[9]])+  sd(data.I.0[[10]])+  sd(data.I.0[[11]])+  sd(data.I.0[[12]])+  sd(data.I.0[[13]])+  sd(data.I.0[[14]])+  sd(data.I.0[[15]])+  sd(data.I.0[[16]])+  sd(data.I.0[[17]])+  sd(data.I.0[[18]])+  sd(data.I.0[[19]])+  sd(data.I.0[[20]])+  sd(data.I.0[[21]])+  sd(data.I.0[[22]])+  sd(data.I.0[[23]])+  sd(data.I.0[[24]])+  sd(data.I.0[[25]])+  sd(data.I.0[[26]])+  sd(data.I.0[[27]])+  sd(data.I.0[[28]]))/28
(sd(data.I.12[[1]])+   sd(data.I.12[[2]])+   sd(data.I.12[[3]])+   sd(data.I.12[[4]])+   sd(data.I.12[[5]])+   sd(data.I.12[[6]])+   sd(data.I.12[[7]])+   sd(data.I.12[[8]])+   sd(data.I.12[[9]])+   sd(data.I.12[[10]])+   sd(data.I.12[[11]])+   sd(data.I.12[[12]])+   sd(data.I.12[[13]])+   sd(data.I.12[[14]])+   sd(data.I.12[[15]])+   sd(data.I.12[[16]])+   sd(data.I.12[[17]])+   sd(data.I.12[[18]])+   sd(data.I.12[[19]])+   sd(data.I.12[[20]])+   sd(data.I.12[[21]])+   sd(data.I.12[[22]])+   sd(data.I.12[[23]])+   sd(data.I.12[[24]])+   sd(data.I.12[[25]])+   sd(data.I.12[[26]])+   sd(data.I.12[[27]])+   sd(data.I.12[[28]]))/28

### significant changes sum score over time
t.test(data$IDS_sum.1, data$IDS_sum.2, paired=T) #t = 51.87, df = 2521, p-value < 2.2e-16


##### HISTOGRAMS
names(IDS_sum.1)[names(IDS_sum.1)=="IDS_sum.1"] <- "length"
names(IDS_sum.2)[names(IDS_sum.2)=="IDS_sum.2"] <- "length"
IDS_sum.1$time <- 'baseline'
IDS_sum.2$time <- 'year 2'
vegLengths <- rbind(IDS_sum.1,IDS_sum.2)

# pdf("IDS_SR_density.pdf")
# ggplot(vegLengths, aes(length, fill = time)) + geom_density(alpha = 0.2)+ theme_bw() +
#   xlab("IDS-SR") + ylab("Density") 
# dev.off()




##### PARALLEL ANALYSIS & SCREE PLOTS
t0.I <- cor_auto(data.I.0)
t12.I <- cor_auto(data.I.12)

### conduct parallel analysis to receive PA control eigenvalues
load(file = "PA.t0.I.Rdata")
# PA.t0.I = fa.parallel(data.I.0, fm="wls", cor="poly", fa="pc", quant=.95, n.iter=50) # extract 4 components
# save(PA.t0.I, file = "PA.t0.I.Rdata")
# eigen(t0.I)$values        #EV of data from eigen function
# PA.t0.I$pc.values         #equal results of data from fa.parallel analysis; also equals mplus EFA results
# describe(PA.t0.I$values)  #the first 10 entries of the column "mean" are the ones we need to plot results of the PA.

load(file = "PA.t0.I.Rdata")
# PA.t12.I = fa.parallel(data.I.12, fm="wls", cor="poly", fa="pc", quant=.95, n.iter=50) # extract 3 components
# save(PA.t12.I, file = "PA.t12.I.Rdata")

### extract eigenvalues from data
eigen.I <- rbind(
  data.frame(t = 0,x = 1:ncol(t0.I),
    eigen = eigen(t0.I)$values),
  data.frame(t = 2,x = 1:ncol(t12.I),
    eigen = eigen(t12.I)$values))

### add eigenvalues from simulated PA manually to extracted eigenvalues
eigen.I2 <- eigen.I
t <- c("PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA","PA")
x <- 1:28
#R psych fa.parallel.poly PA simulated eigenvalues
eigen <- c(1.57,1.48,1.40,1.35,1.31,1.28,1.23,1.16,1.11,1.05,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2)
#mplus MLR PA simulated eigenvalues
#eigen <- c(1.195,1.169,1.15,1.135,1.118,1.103,1.089,1.075,1.063,1.050,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2)
df.I <- data.frame(t,x,eigen)
eigen.I2 <- rbind(eigen.I2, df.I)

g.I2color <- ggplot(eigen.I2, aes(x = x, y = eigen, colour = factor(t))) + 
  geom_line() + geom_point(size=3) + theme_bw() + theme(legend.title=element_blank()) +
  scale_x_continuous(limits = c(1, 7), breaks = 1:7) +
  scale_y_continuous(limits = c(0, 13), breaks = c(0,2,4,6,8,10,12)) +
  xlab("Factors") +
  ylab("Eigenvalues") + 
  ggtitle("IDS-SR Eigenvalues at years 0 and 2")
g.I2bw <- ggplot(eigen.I2, aes(x = x, y = eigen, shape = t)) + 
  geom_line() + geom_point(size=3) + theme_bw() + theme(legend.title=element_blank()) +
  scale_x_continuous(limits = c(1, 7), breaks = 1:7) +
  scale_y_continuous(limits = c(0, 13), breaks = c(0,2,4,6,8,10,12)) +
  xlab("Factors") +
  ylab("Eigenvalues") + 
  ggtitle("IDS-SR Eigenvalues at years 0 and 2")

ggsave(plot=g.I2color,height=5,width=7, filename="eigenvalues_IDS_SR_color.pdf", useDingbats=FALSE)
ggsave(plot=g.I2bw,height=5,width=7, filename="eigenvalues_IDS_SR_bw.pdf", useDingbats=FALSE)




##### INCREASING CORRELATIONS AND ALPHA

# matrix sum without diagonal (now for real :-))
mean(t0.I[upper.tri(t0.I)])
mean(t12.I[upper.tri(t12.I)])

# alpha (psych package)
alpha(t0.I)
alpha(t12.I)
